package com.madeu.controller.mobile.mobileuser;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobileuser.MobileUserService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;


@Slf4j
@Controller
public class MobileUserController extends ManagerDraftAction{

	@Autowired
	private MobileUserService mobileUserService;

	/**
	 * 회원정보 설정 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserAccountIntro.do")
	public String  selectUserAccountIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileUserController  selectUserAccountIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try {
			if (!mobileCheckLogin(session)) {
				return "/mobile/login/login";
			} else {
			}
		} catch (Exception e) {
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobileUserController  selectUserAccountIntro END");
		return "/mobile/user/selectUserAccount";
	}

	/**
	 * 계정찾기 화면으로 이동.
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserIdIntro.do")
	public String  selectUserIdIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileUserController  selectUserIdIntro START");
		log.debug("MobileUserController  selectUserIdIntro END");
		return "/mobile/user/selectUserId";
	}

	/**
	 * 비밀번호 찾기 화면으로 이동.
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserPasswordIntro.do")
	public String  selectUserPasswordIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileUserController  selectUserPasswordIntro START");
		log.debug("MobileUserController  selectUserPasswordIntro END");
		return "/mobile/user/selectUserPassword";
	}

	/**
	 * 비밀번호 재설정 화면으로 이동.
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/updateUserPasswordIntro.do")
	public String  updateUserPasswordIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileUserController  updateUserPasswordIntro START");
		log.debug("MobileUserController  updateUserPasswordIntro END");
		return "/mobile/user/updateUserPassword";
	}

	/**
	 * 고객 아이디 정보 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserId.do")
	public String selectUserId(HttpSession session,HttpServletRequest request, HttpServletResponse response,Model model) {
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map =  new HashMap<>();
		try {
			paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
			map = mobileUserService.selectUserId(paramMap);

			if (map != null && Constants.OK.equals(map.get("msgCode"))) {
				model.addAttribute("userIdData", map.get("rows"));
			} else {
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if (map.get("msgDesc") == null || map.get("msgDesc").equals("")) {
					map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
				model.addAttribute("errorMsg", map.get("msgDesc"));
			}

		} catch (Exception e) {
			e.printStackTrace();
			model.addAttribute("errorMsg", "오류가 발생했습니다. 다시 시도해 주세요.");
			return "/mobile/user/selectUserId";
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileUserController selectUserAccount END");
		return "/mobile/user/selectUserId";
	}

	/**
	 * 고객 연락처 정보 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserPhoneNumber.do")
	public String selectUserPhoneNumber(HttpSession session,HttpServletRequest request, HttpServletResponse response,Model model) {
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map =  new HashMap<>();
		try {
			map = mobileUserService.selectUserPhoneNumber(paramMap);
			String userPhoneNumber = String.valueOf(map.get("userPhoneNumber"));
			if (!Objects.equals(userPhoneNumber, "null") && Constants.OK.equals(map.get("msgCode"))) {
				model.addAttribute("userPhoneNumber", String.valueOf(map.get("userPhoneNumber")));
			} else {
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if (map.get("msgDesc") == null || map.get("msgDesc").equals("")) {
					map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
				model.addAttribute("errorMsg", map.get("msgDesc"));
			}

		} catch (Exception e) {
			e.printStackTrace();
			model.addAttribute("errorMsg", "오류가 발생했습니다. 다시 시도해 주세요.");
			return "/mobile/user/selectUserPassword";
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileUserController selectUserPassword END");
		return "/mobile/user/selectUserPassword";
	}

	/**
	 * 고객 정보 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectUserAccount.do")
	public ModelAndView selectUserAccount(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobileUserController selectUserAccount START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileUserService.selectUserAccount(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileUserController selectUserAccount END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 이메일 계정 중복 확인
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/selectEmailCheck.do")
	public ModelAndView selectEmailCheck(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobileUserController selectEmailCheck START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			map = mobileUserService.selectEmailCheck(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileUserController selectEmailCheck END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 비밀번호 수정(설정-비밀번호 변경)
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/updatePassword.do")
	public ModelAndView updatePassword(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("MobileUserController updatePassword START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = mobileUserService.updatePassword(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
//				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
//				HashMap<String, Object> insertMap = new HashMap<String, Object>();
//
//				insertMap.put("url", "/webmember/updateMemberPassword.do");
//				insertMap.put("func", "updateMemberPassword");
//				insertMap.put("funcName", "직원 비밀번호 수정");
//				insertMap.put("service", "webMemberService");
//				insertMap.put("serviceName", "직원 비밀번호 수정");
//				insertMap.put("requestValue", String.valueOf(paramMap));
//				insertMap.put("responseValue", String.valueOf(map));
//				insertMap.put("tId", map.get("tId"));
//				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
//					insertMap.put("resultCode", "SUCCESS");
//				}
//				else{
//					insertMap.put("resultCode", "ERROR");
//				}
//				insertMap.put("resultMsg", String.valueOf(errorMsg));
//				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
//
//				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("MobileUserController updateMemberPassword END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 비밀번호 수정2(비밀번호 찾기)
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/updateUserPassword.do")
	public String updateUserPassword(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("MobileUserController updateUserPassword START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
            map = mobileUserService.updateUserPassword(paramMap);
            if (map != null && Constants.OK.equals(map.get("msgCode"))) {
                model.addAttribute("userIdData", map.get("rows"));
			} else {
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if (map.get("msgDesc") == null || map.get("msgDesc").equals("")) {
					map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
				model.addAttribute("errorMsg", map.get("msgDesc"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			model.addAttribute("errorMsg", "오류가 발생했습니다. 다시 시도해 주세요.");
			return "/mobile/user/updateUserPassword";
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
//				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
//				HashMap<String, Object> insertMap = new HashMap<String, Object>();
//
//				insertMap.put("url", "/webmember/updateMemberPassword.do");
//				insertMap.put("func", "updateMemberPassword");
//				insertMap.put("funcName", "직원 비밀번호 수정");
//				insertMap.put("service", "webMemberService");
//				insertMap.put("serviceName", "직원 비밀번호 수정");
//				insertMap.put("requestValue", String.valueOf(paramMap));
//				insertMap.put("responseValue", String.valueOf(map));
//				insertMap.put("tId", map.get("tId"));
//				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
//					insertMap.put("resultCode", "SUCCESS");
//				}
//				else{
//					insertMap.put("resultCode", "ERROR");
//				}
//				insertMap.put("resultMsg", String.valueOf(errorMsg));
//				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
//
//				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("MobileUserController updateUserPassword END");
		return "/mobile/user/updateUserPassword";
	}

	/**
	 * 이메일 수정
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobileuser/updateEmail.do")
	public ModelAndView updateEmail(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("MobileUserController updateEmail START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = mobileUserService.updateEmail(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
//				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
//				HashMap<String, Object> insertMap = new HashMap<String, Object>();
//
//				insertMap.put("url", "/webmember/updateMemberPassword.do");
//				insertMap.put("func", "updateMemberPassword");
//				insertMap.put("funcName", "직원 비밀번호 수정");
//				insertMap.put("service", "webMemberService");
//				insertMap.put("serviceName", "직원 비밀번호 수정");
//				insertMap.put("requestValue", String.valueOf(paramMap));
//				insertMap.put("responseValue", String.valueOf(map));
//				insertMap.put("tId", map.get("tId"));
//				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
//					insertMap.put("resultCode", "SUCCESS");
//				}
//				else{
//					insertMap.put("resultCode", "ERROR");
//				}
//				insertMap.put("resultMsg", String.valueOf(errorMsg));
//				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
//
//				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("MobileUserController updateEmail END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

}